/**
 * This file was auto-generated by openapi-typescript.
 * Do not make direct changes to the file.
 */

export interface paths {
  "/data": {
    /** Data query API which returns matching links to department */
    get: {
      parameters: {
        query: {
          uris: string;
          /** Type of data returned */
          types: string;
        };
      };
      responses: {
        /** OK */
        200: {
          schema: definitions["DataResponse"];
        };
        /** Internal server error */
        500: unknown;
      };
    };
  };
  "/departments/search": {
    /** Department query API which returns matching links to other departments */
    get: {
      parameters: {
        query: {
          /** Query search term */
          q: string;
          /** The number of items requested, defaulted to 50 and limited to 1000. */
          limit?: number;
          /** The first row of resources to retrieve, starting at 0. Use this parameter as a pagination mechanism along with the limit parameter. */
          offset?: number;
        };
      };
      responses: {
        /** OK */
        200: {
          schema: definitions["DepartmentResponse"];
        };
        /** Query term not specified */
        400: unknown;
        /** Internal server error */
        500: unknown;
      };
    };
  };
  "/health": {
    /** API to query the app for current health status */
    get: {
      responses: {
        /** OK */
        200: {
          schema: definitions["Health"];
        };
        /** Internal Server Error */
        500: unknown;
      };
    };
  };
  "/search": {
    /** Default ONS query API which combines the content with type counts */
    get: {
      parameters: {
        query: {
          /** Query search term. */
          q: string;
          /** Comma separated list of content types to be returned. */
          content_type?: string[];
          /** Determines whether to return HTML highlighted fields. */
          highlight?: boolean;
          /** The order to return the results. */
          sort?: string;
          /** The number of items requested, defaulted to 50 and limited to 1000. */
          limit?: number;
          /** The first row of resources to retrieve, starting at 0. Use this parameter as a pagination mechanism along with the limit parameter. */
          offset?: number;
        };
      };
      responses: {
        /** OK */
        200: {
          schema: definitions["GetSearchResponse"];
        };
        /** Query term not specified */
        400: unknown;
        /** Internal server error */
        500: unknown;
      };
    };
    /** Request a new search index and receive the name of the new index created in response. Endpoint requires service or user authentication. */
    post: {
      responses: {
        /** OK */
        200: {
          schema: definitions["PostSearchResponse"];
        };
        /** Internal server error */
        500: unknown;
      };
    };
  };
  "/timeseries": {
    /** API to query the app for timeseries by id */
    get: {
      parameters: {
        query: {
          /** The timeseries id. */
          cdid: string;
        };
      };
      responses: {
        /** OK */
        200: {
          schema: definitions["TimeseriesResponse"];
        };
        /** Internal server error */
        500: unknown;
      };
    };
  };
}

export interface definitions {
  DataResponse: {
    /** @description A json list containing data associated with a particular dataset */
    responses?: {
      _shards?: definitions["ShardsItem"];
      hits?: definitions["HitsObject"];
      timed_out?: boolean;
      /** @description Time taken to execute query in milliseconds */
      took?: number;
    }[];
  };
  GetSearchResponse: {
    /**
     * @description Number of search results which match query
     * @example 80
     */
    count: number;
    /**
     * @description Time taken to execute query in milliseconds
     * @example 530
     */
    took: number;
    /** @description List of content types included in results */
    content_types: definitions["ContentType"][];
    /** @description List of matching content items for the current page */
    items: definitions["ContentItem"][];
    /** @description List of suggested alternative similar search queries */
    suggestions?: string[];
    /**
     * @description List of suggested alternative search queries from current search query
     * @example UK,economy,inflation rate
     */
    alternative_suggestions?: string[];
  };
  PostSearchResponse: {
    /**
     * @description Name of new empty search index
     * @example ons1636458168532
     */
    index_name: string;
  };
  DepartmentResponse: {
    /**
     * @description Number of search results which match query
     * @example 80
     */
    count: number;
    /**
     * @description Time taken to execute query in milliseconds
     * @example 530
     */
    took: number;
    /** @description List of matching content items for the current page */
    items?: definitions["DepartmentItem"][];
  };
  ContentType: {
    type: string;
    count: number;
  };
  ContentItem: {
    description: {
      contact?: {
        email: string;
        name: string;
        telephone?: string;
      };
      dataset_id?: string;
      edition?: string;
      highlight?: definitions["Highlight"];
      headline1?: string;
      headline2?: string;
      headline3?: string;
      keywords?: string[];
      latest_release?: boolean;
      /** @example English */
      language?: string;
      meta_description?: string;
      national_statistic?: boolean;
      /** @example 14 August 2015 */
      next_release?: string;
      pre_unit?: string;
      /** Format: date-time */
      release_date?: string;
      source?: string;
      summary: string;
      title: string;
      unit?: string;
    };
    type: string;
    uri: string;
  };
  /** @description Fields that contain at least 1 matching term from query 'q' parameter. The values contain the following embedded tags "...<em class="highlight">{matched term}</em>..." */
  Highlight: {
    dataset_id?: string;
    edition?: string;
    keywords?: string[];
    meta_description?: string;
    summary?: string;
    title?: string;
  };
  DepartmentItem: {
    code?: string;
    name?: string;
    url?: string;
    terms?: string[];
    matches?: {
      terms?: string[];
    }[];
  };
  Health: {
    elasticsearch?: string;
    /** @example available */
    dp_fasttext?: string;
  };
  ShardsItem: {
    failed?: number;
    successful?: number;
    total?: number;
  };
  HitsObject: {
    hits?: definitions["HitsItem"][];
    max_score?: number;
    total?: number;
  };
  HitsItem: {
    _id?: string;
    _index?: string;
    _score?: number;
    _source?: {
      code?: string;
      name?: string;
      terms?: string[];
      url?: string;
    };
    _type?: string;
  };
  TimeseriesResponse: {
    /**
     * @description Time taken to execute query in milliseconds
     * @example 530
     */
    took?: number;
    timed_out?: boolean;
    _shards?: definitions["ShardsItem"][];
    hits?: {
      _index?: string;
      /** @example timeseries */
      _type?: string;
      _id?: string;
      _score?: string;
      _source?: {
        uri?: string;
      };
    }[];
    sort?: number[];
  };
}

export interface operations {}

export interface external {}
